/************************************************************************
 *                                                                      *
 * Open File Manager - ncurses file manager for GNU/Linux               *
 * (c) 2001, 2002 Slawomir Strumecki, Raphael Bugajewski                *
 *                                                                      *
 * This program is free software, you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful,      *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of       *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the        *
 * GNU General Public License for more details.                         *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the Free Software          *
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 *
 *                                                                      *
 ************************************************************************
 *                                                                      *
 * If you want to contact us, please use the following address(es):     *
 *                                                                      *
 *     Raphael Bugajewski               Slawomir Strumecki              *
 *     Kl. Mittelstr. 1                 mailto: <logospam@poczta.fm>    *
 *     13585 Berlin / Germany                                           *
 *     Tel.: +49 (175) 331 93 92                                        *
 *     mailto: <born@bugajewski.de>                                     *
 *                                                                      *
 ************************************************************************/

#ifndef __OFM_MENU__
#define __OFM_MENU__

#include <menu.h>

typedef struct tomenu {
    MENU *menu;
    WINDOW *win;
    WINDOW *subwin;
    WINDOW *menubar;
    int items_count;
    int menu_width;
    int x,y;
} OMENU;

OMENU *menuCreate(int x, int y, char* names[], char* descs[]);
int menuDelete(OMENU *om);
int menuPost(OMENU *om);
int menuUnpost(OMENU *om);
int menuProcess(OMENU *om, int c);
int menuCurrentItem(OMENU *om);

int menuBarCreate(char *names[]);
int menuBarRefresh();
int menuBarDelete();

#endif /* __OFM_MENU__ */
